//////////////////////////////////////////////////////////////////////
//
//  FANCYFNT.PRG
//
//  Copyright:
//      Alaska Software, (c) 1997-2009. All rights reserved.
//
//  Contents:
//      This sample program renders some text strings demonstrating the GRA
//      engine's GraStringAt() primitive.
//
//////////////////////////////////////////////////////////////////////
#include "appevent.ch"
#include "xbp.ch"
#include "gra.ch"
#include "common.ch"


******************************************************************************
* Main() procedure and event loop
******************************************************************************
PROCEDURE appsys
return

PROCEDURE Main
LOCAL nEvent, mp1, mp2, oXbp
LOCAL oPS
LOCAL oFont
LOCAL aMatrix
LOCAL i
LOCAL aAttrF
LOCAL nAngle

LOCAL oDlg
LOCAL oStatic
LOCAL oBitmap
LOCAL aPos     := {0,0}
LOCAL aSize    := {640,480}
LOCAL nColor   := GRA_CLR_WHITE

   oDlg        := XbpDialog():new(AppDesktop(),, {0,0} )
   oDlg:title  := "Parent Window"
   oDlg:titlebar := .T.
   oDlg:clientSize := aSize
   oDlg:create()
   CenterControl(oDlg)

   oStatic := XbpStatic():new(oDlg:drawingArea,, {0,0},aSize  )
   oStatic:type := XBPSTATIC_TYPE_BITMAP
   oStatic:create()

* ------------------------------------------------------------- *

   oBitmap := XbpBitmap() :new() :create()       // create Bitmap
   oPS := XbpPresSpace():new()                   // NO :Create() here
   oPS:create( oBitmap, { aSize[1],aSize[2] } )  // here :Create()
   oBitmap:presSpace( oPS )                      // assing to Bitmap:presSpace
   oBitmap:make( aSize[1],aSize[2] )             // make empty Bitmap

   GraSetColor( oPS, nColor, nColor )            // Background Color
   GraBox( oPS, {0,0}, {aSize[1],aSize[2]}, 1 )  // fill Background

* ------------------------------------------------------------- *

   oFont := XbpFont():new():create("20.Arial Bold")
   GraSetFont(oPS , oFont)
   aAttrF := ARRAY( GRA_AS_COUNT )
   aAttrF [ GRA_AS_COLOR      ] := GRA_CLR_BLACK
   aAttrF [ GRA_AS_HORIZALIGN ] := GRA_HALIGN_LEFT
   aAttrF [ GRA_AS_VERTALIGN  ] := GRA_VALIGN_HALF
   GraSetAttrString( oPS, aAttrF )
   GraStringAt( oPS, { 20,350 }, 'The text before the rotation' )

   *********************************************
   ******** Save before rotating the image *****
   *********************************************

   FERASE( "Picture1.JPG" )
   oBitmap:saveFile("Picture1.JPG",XBPBMP_FORMAT_JPG)
   oStatic:Setcaption(oBitmap)

* ------------------------------------------------------------- *

   /*
    * Rotate text strings to show transforms via
    * SetGraTransform()
    */

   oFont := XbpFont():new():create("10.Arial Bold")
   GraSetFont(oPS , oFont)
   aAttrF := ARRAY( GRA_AS_COUNT )
   aAttrF [ GRA_AS_COLOR      ] := GRA_CLR_BLACK
   aAttrF [ GRA_AS_HORIZALIGN ] := GRA_HALIGN_CENTER
   aAttrF [ GRA_AS_VERTALIGN  ] := GRA_VALIGN_HALF
   GraSetAttrString( oPS, aAttrF )

   nAngle := 10

   aMatrix := GraInitMatrix()
   FOR i:=1 TO nAngle
      GraRotate( oPS, aMatrix, 360/nAngle, {200, 200}, GRA_TRANSFORM_ADD )
      oPS:setGraTransform( aMatrix, GRA_TRANSFORM_REPLACE )
      GraStringAt( oPS, {100,100}, ALLTRIM(STR(i))+"-Rotated text..." )
   NEXT

   FERASE( "Picture2.JPG" )
   oBitmap:saveFile("Picture2.JPG",XBPBMP_FORMAT_JPG)
   oStatic:Setcaption(oBitmap)

* ------------------------------------------------------------- *

   aMatrix := GraInitMatrix()                    // NEED new GraInitMatrix()


   ***** Rotate the image (360) for proper rendering

   GraRotate( oPS, aMatrix, 360, {200, 200}, GRA_TRANSFORM_ADD )
   oPS:setGraTransform( aMatrix, GRA_TRANSFORM_REPLACE )

   oFont := XbpFont():new():create("20.Arial Bold")
   GraSetFont(oPS , oFont)
   aAttrF := ARRAY( GRA_AS_COUNT )
   aAttrF [ GRA_AS_COLOR      ] := GRA_CLR_BLACK
   aAttrF [ GRA_AS_HORIZALIGN ] := GRA_HALIGN_LEFT
   aAttrF [ GRA_AS_VERTALIGN  ] := GRA_VALIGN_HALF
   GraSetAttrString( oPS, aAttrF )
   GraStringAt( oPS, { 20,50 }, 'The text after the label at an angle' )

   *********************************************
   **** Save after image rotation **************
   *********************************************

   FERASE( "Picture3.JPG" )
   oBitmap:saveFile("Picture3.JPG",XBPBMP_FORMAT_JPG)
   oStatic:Setcaption(oBitmap)

* ------------------------------------------------------------- *

   SetAppFocus(oStatic)

   nEvent := 0
   DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp)
      DO CASE
         CASE nEvent == xbeP_Keyboard .AND. mp1 == xbeK_ESC
            EXIT
      OTHERWISE
         oXbp:HandleEvent( nEvent, mp1, mp2 )
      ENDCASE
   ENDDO

RETURN

// EOF